SoVRMLAnchor(3)

NAME
SoVRMLAnchor - The SoVRMLAnchor class is used for linking to other URL resources.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLAnchor.h>

Inherits SoVRMLParent.

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLAnchor (void)
virtual void handleEvent (SoHandleEventAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
static void setFetchURLCallBack (SoVRMLAnchorCB *, void *closure)

  Public Attributes
SoMFString url
SoSFString description
SoMFString parameter
SoSFVec3f bboxCenter
SoSFVec3f bboxSize

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLAnchor ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLAnchor class is used for linking to other URL resources. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

Anchor {
  eventIn      MFNode   addChildren
  eventIn      MFNode   removeChildren
  exposedField MFNode   children        []
  exposedField SFString description     ''
  exposedField MFString parameter       []
  exposedField MFString url             []
  field        SFVec3f  bboxCenter      0 0 0     # (-inf, inf)
  field        SFVec3f  bboxSize        -1 -1 -1  # (0, inf) or -1,-1,-1
}

The Anchor grouping node retrieves the content of a URL when the user activates (e.g., clicks) some geometry contained within the Anchor node's children. If the URL points to a valid VRML file, that world replaces the world of which the Anchor node is a part (except when the parameter field, described below, alters this behaviour). If non-VRML data is retrieved, the browser shall determine how to handle that data; typically, it will be passed to an appropriate non-VRML browser. Exactly how a user activates geometry contained by the Anchor node depends on the pointing device and is determined by the VRML browser. Typically, clicking with the pointing device will result in the new scene replacing the current scene. An Anchor node with an empty url does nothing when its children are chosen. A description of how multiple Anchors and pointing-device sensors are resolved on activation is contained in 4.6.7, Sensor nodes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7).

More details on the children, addChildren, and removeChildren fields and eventIns can be found in 4.6.5, Grouping and children nodes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.5).

The description field in the Anchor node specifies a textual description of the Anchor node. This may be used by browser-specific user interfaces that wish to present users with more detailed information about the Anchor. The parameter exposed field may be used to supply any additional information to be interpreted by the browser. Each string shall consist of 'keyword=value' pairs. For example, some browsers allow the specification of a 'target' for a link to display a link in another part of an HTML document. The parameter field is then:

Anchor {
  parameter [ 'target=name_of_frame' ]
  ...
}

An Anchor node may be used to bind the initial Viewpoint node in a world by specifying a URL ending with '#ViewpointName' where 'ViewpointName' is the name of a viewpoint defined in the VRML file. For example:

Anchor {
  url 'http://www.school.edu/vrml/someScene.wrl#OverView'
  children  Shape { geometry Box {} }
}

specifies an anchor that loads the VRML file 'someScene.wrl' and binds the initial user view to the Viewpoint node named 'OverView' when the Anchor node's geometry (Box) is activated. If the named Viewpoint node is not found in the VRML file, the VRML file is loaded using the default Viewpoint node binding stack rules (see VRMLViewpoint). If the url field is specified in the form '#ViewpointName' (i.e. no file name), the Viewpoint node with the given name ('ViewpointName') in the Anchor's runtime name scope(s) shall be bound (set_bind TRUE). The results are undefined if there are multiple Viewpoints with the same name in the Anchor's runtime name scope(s). The results are undefined if the Anchor node is not part of any runtime name scope or is part of more than one runtime name scope. See 4.4.6, Runtime name scope, for a description of runtime name scopes. See VRMLViewpoint, for the Viewpoint transition rules that specify how browsers shall interpret the transition from the old Viewpoint node to the new one. For example:

Anchor {
  url '#Doorway'
  children Shape {
    geometry Sphere {}
  }
}

binds the viewer to the viewpoint defined by the 'Doorway' viewpoint in the current world when the sphere is activated. In this case, if the Viewpoint is not found, no action occurs on activation. More details on the url field are contained in 4.5, VRML and the World Wide Web (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.5). The bboxCenter and bboxSize fields specify a bounding box that encloses the Anchor's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. The default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and if needed shall be calculated by the browser. More details on the bboxCenter and bboxSize fields can be found in 4.6.4, Bounding boxes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.4).

Constructor & Destructor Documentation

  SoVRMLAnchor::SoVRMLAnchor (void)
Default constructor.

  SoVRMLAnchor::~SoVRMLAnchor () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLAnchor::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLAnchor::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoVRMLParent.

  const SoFieldData ** SoVRMLAnchor::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLAnchor::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoVRMLParent.

  void SoVRMLAnchor::initClass (void) [static]

  void SoVRMLAnchor::setFetchURLCallBack (SoVRMLAnchorCB * f, void * closure) [static]
Sets the callback that will be called when the node is selected.

  void SoVRMLAnchor::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoGroup.

Member Data Documentation

  SoVRMLAnchor::url
The URL string.

  SoVRMLAnchor::description
The textual description of the URL.

  SoVRMLAnchor::parameter
May be used to supply additional information to the browser.

Each string should be pairs of keyword = value.

  SoVRMLAnchor::bboxCenter
Children bounding box hint center. Default value is (0, 0, 0).

  SoVRMLAnchor::bboxSize
Children bounding box size hint. Default value is (-1, -1, -1).

Author

Generated automatically by Doxygen for Coin from the source code.